import { attachShadow, h, Host, proxyCustomElement } from '@stencil/core/internal/client';
export { setAssetPath, setPlatformOptions } from '@stencil/core/internal/client';

const dateRangePickerCss = "body{font-family:monospace;font-weight:bold}body p{margin-bottom:10px}.picker{background-color:#cecece;width:100px;margin:0 auto}.picker .ct{width:100px;color:#000}";

const DateRangePicker = class extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    attachShadow(this);
  }
  render() {
    return (h("div", { class: "picker" }, h("div", { class: "ct" }, h("p", null, "Component 1"))));
  }
  static get style() { return dateRangePickerCss; }
};

const hcLoadingBoxCss = "body{font-family:monospace;font-weight:bold}body p{margin-bottom:10px}.loadingbox{position:relative;top:80%}.loadingbox .centerdiv{height:150px;display:flex;justify-content:center;align-items:center}.loadingbox .message{text-align:center;position:relative;left:-70px;top:20px;font-size:10px;color:#cecece}.loadingbox .animate{display:flex}.loadingbox .animate>li{list-style:none;height:10px;width:10px;background-color:red;margin:0 2px;border-radius:50%;animation:bounce 1s linear infinite}.loadingbox .no-animate{display:flex}.loadingbox .no-animate>li{list-style:none;height:10px;width:10px;background-color:red;margin:0 2px;border-radius:50%}@keyframes bounce{0%{transform:translateY(0px)}50%{transform:translateY(-40px)}100%{transform:translateY(0px)}}.loadingbox ul li:nth-child(1){animation-delay:0.2s;background-color:#7C33F3}.loadingbox ul li:nth-child(2){animation-delay:0.6s;background-color:#F700BA}.loadingbox ul li:nth-child(3){animation-delay:0.1s;background-color:#FF287F}.loadingbox ul li:nth-child(4){animation-delay:0.8s;background-color:#FF8152}.loadingbox ul li:nth-child(5){animation-delay:0.5s;background-color:#FFC246}.loadingbox ul li:nth-child(6){animation-delay:0.1s;background-color:#F9F871}";

const HcLoadingBox$1 = class extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    attachShadow(this);
    this.open = true;
  }
  handleClick() {
    this.open = !this.open;
  }
  // @Watch('message')
  // watchMessageHandler(oldValue: boolean, newValue: boolean) {
  //   console.log(oldValue);
  //   console.log(newValue);
  // }
  watchOpenHandler(newValue) {
    if (newValue) {
      this.message = '出門 ...';
    }
    else {
      this.message = '呆在家 ...';
    }
  }
  componentWillRender() {
    console.log('componentWillRender()');
  }
  componentDidRender() {
    console.log('componentDidRender()');
  }
  componentWillLoad() {
    console.log('componentWillLoad()');
  }
  componentDidLoad() {
    console.log('componentDidLoad()');
  }
  render() {
    console.log('render()');
    return (h("div", { class: "loadingbox" }, h("div", { class: "centerdiv" }, h("ul", { class: this.open ? "animate" : "no-animate" }, h("li", null), h("li", null), h("li", null), h("li", null), h("li", null), h("li", null)), h("span", { class: "message" }, this.message))));
  }
  static get watchers() { return {
    "open": ["watchOpenHandler"]
  }; }
  static get style() { return hcLoadingBoxCss; }
};

const hcTestComponentCss = ":host{display:block}.hc{width:300px;height:500px;position:absolute;top:0;bottom:0;left:0;right:0;margin:0 auto}";

const HcTestComponent$1 = class extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    attachShadow(this);
  }
  componentWillRender() {
    console.log('componentWillRender()');
  }
  componentDidRender() {
    console.log('componentDidRender()');
  }
  componentWillLoad() {
    console.log('componentWillLoad()');
  }
  componentDidLoad() {
    console.log('componentDidLoad()');
  }
  render() {
    console.log('render()');
    return (h(Host, null, h("div", { class: "hc" }, h("slot", null))));
  }
  static get style() { return hcTestComponentCss; }
};

const HcDateRangePicker = /*@__PURE__*/proxyCustomElement(DateRangePicker, [1,"hc-date-range-picker"]);
const HcLoadingBox = /*@__PURE__*/proxyCustomElement(HcLoadingBox$1, [1,"hc-loading-box",{"message":[1025],"open":[32]},[[0,"click","handleClick"]]]);
const HcTestComponent = /*@__PURE__*/proxyCustomElement(HcTestComponent$1, [1,"hc-test-component"]);
const defineCustomElements = (opts) => {
  if (typeof customElements !== 'undefined') {
    [
      HcDateRangePicker,
  HcLoadingBox,
  HcTestComponent
    ].forEach(cmp => {
      if (!customElements.get(cmp.is)) {
        customElements.define(cmp.is, cmp, opts);
      }
    });
  }
};

export { HcDateRangePicker, HcLoadingBox, HcTestComponent, defineCustomElements };
